﻿Type=StaticCode
Version=4
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Type BltData(ch As Int,cmd As Int)
	
	Dim LastCol As Int
	Dim FirstCol As Int
End Sub

Sub Globals
    Dim Qbf(20) As BltData
	Dim Qnt As Int=0
End Sub

Sub PushQ(chs As Int, chc As Int) As Int

		If Qnt > 20 Then Return  -1 ' 表示buffer己滿
		Qnt = Qnt + 1
		Qbf(Qnt-1).ch = chs
		Qbf(Qnt-1).cmd = chc
		
		Return Qnt ' 回傳buffer內存數量
End Sub

Sub PopQ(intQ() As BltData) As Int
		Dim n1,n2 As Int
		
		If(intQ.Length<10) Then Return  -2 ' buffer長度問題
		If(intQ(0)=0) Then Return -1	' 長度為0, 表示沒有資料
		n2 = intQ(1) ' 留存位置1的值
		For n1=1 To intQ.Length-2
			intQ(n1) = intQ(n1+1)
		Next
		intQ(n1) = -1
		intQ(0) = intQ(0) -1 ' buffer長度減1
		Return n2
End Sub

Sub ResetQ() As Int
		Dim  n1 As Int
		
		If(intQ.Length < 2) Then Return -2 ' buffer長度問題
		' Q大小設為0
		intQ(0) = 0
		' 清成預設值
		For n1=1 To intQ.Length-1
			intQ(n1) = -1
		Next
		' 回傳array長度
		Return intQ.Length
End Sub

Private Sub ByteToHex(fValue As Int) As Byte()
	Dim m1,n1 As Int
	Dim buff(6) As Byte
	
	buff(0) = 0x30
	buff(1) = 0x30
	
	m1 = fValue Mod 16    '  餘數
	n1 = (fValue - m1) /16 ' 商數
	If m1 > 10 Then
		buff(1) = 0x41+m1-10
	Else
		buff(1) = 0x30+m1
	End If
	
	If n1 > 10 Then
		buff(0) = 0x41+n1-10
	Else
		buff(0) = 0x30+n1
	End If
	
	Return buff
End Sub

Sub SetTagAndText(lb1 As Label, i1 As Int)
	lb1.Tag = i1
	lb1.Text = i1
End Sub

Sub GetARGB(Color As Int) As Int()
    Dim res(4) As Int
    res(0) = Bit.UnsignedShiftRight(Bit.AND(Color, 0xff000000), 24)
    res(1) = Bit.UnsignedShiftRight(Bit.AND(Color, 0xff0000), 16)
    res(2) = Bit.UnsignedShiftRight(Bit.AND(Color, 0xff00), 8)
    res(3) = Bit.AND(Color, 0xff)
    Return res
End Sub

Sub	SetButtonColor1(btn As Button,bColor,tColor As Int)
	btn.Color = bColor
	btn.TextColor = tColor
End Sub

' 將資料寫入BT送出
Sub StringToBT(sTxt As String,AStream1 As AsyncStreams)
		Dim buff() As Byte
	
		If 	AStream1.IsInitialized Then
			buff = sTxt.GetBytes("UTF8")
			If 	buff.Length>0 Then
				AStream1.Write2(buff,0,buff.length)
			End If 
		End If
End Sub

Sub ColorToBlueTooth(AStream  As AsyncStreams,iColor As Int)
	Dim res(4) As Int
	Dim buff(20) As Byte
	Dim Conv As ByteConverter
	Dim buff1(8) As Byte
	
	' get the color components
    res(0) = Bit.UnsignedShiftRight(Bit.AND(iColor, 0xff000000), 24)
	' Blue := (MyColor shr 16) AND $FF;
    res(1) = Bit.UnsignedShiftRight(Bit.AND(iColor, 0xff0000), 16)
	' Green := (MyColor shr 8) AND $FF;
    res(2) = Bit.UnsignedShiftRight(Bit.AND(iColor, 0xff00), 8)
	' Red := MyColor AND $FF;
    res(3) = Bit.AND(iColor, 0xff)
	' Format('&C%.2x%.4x%.4x%.2x%.2x%.2x', [fID, fChannel, 3, dat[0],dat[1], dat[2]]);
	buff(0) = 0x26 ' &
	buff(1) = 0x43 ' C
	buff(2) = 0x30 ' 0
	buff(3) = 0x31 ' 1
	buff(4) = 0x30 ' 0
	buff(5) = 0x30 ' 0
	buff(6) = 0x30 ' 0
	buff(7) = 0x31 ' 1
	buff(8) = 0x30 ' 0
	buff(9) = 0x30 ' 0
	buff(10) = 0x30 ' 0
	buff(11) = 0x33 ' 3
	
	buff1 = ByteToHex(res(1))
	buff(12) = buff1(0)
	buff(13) = buff1(1)
	
	buff1 = ByteToHex(res(2))
	buff(14) = buff1(0)
	buff(15) = buff1(1)
	
	buff1 = ByteToHex(res(3))
	buff(16) = buff1(0)
	buff(17) = buff1(1)
	
	AStream.Write2(buff,0,18)
	
	FirstCol = 100
	LastCol = iColor
End Sub

Sub SetKeyValue

End Sub

Sub SetButtonColor(btn As Button,fcolor As Int,corner As Int)
    Dim cdw1 As ColorDrawable
	cdw1.Initialize(fcolor,corner)
    btn.Background = cdw1
End Sub

Sub SetlabelColor(lal As Label,color As Int,corner1 As Int)
    Dim cdw As ColorDrawable
	cdw.Initialize(color,corner1)
    lal.Background = cdw
End Sub