package tw.jylab.blueLT;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "tw.jylab.blueLT", "tw.jylab.blueLT.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "tw.jylab.blueLT", "tw.jylab.blueLT.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "tw.jylab.blueLT.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.Serial _serial1 = null;
public static anywheresoftware.b4a.randomaccessfile.AsyncStreams _astream = null;
public static anywheresoftware.b4a.objects.collections.Map _paireddevices = null;
public static tw.jylab.blueLT.main._nameandmac _selecteddevice = null;
public static boolean _serialconnected = false;
public static int _selected = 0;
public anywheresoftware.b4a.objects.collections.Map _items = null;
public anywheresoftware.b4a.objects.Timer _timer1 = null;
public tw.jylab.blueLT.jylab._bltdata[] _qbf = null;
public static int _actch = 0;
public static int[] _vals = null;
public static int _programs = 0;
public static int _speed = 0;
public anywheresoftware.b4a.objects.LabelWrapper _label9 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnconnect = null;
public anywheresoftware.b4a.objects.ButtonWrapper _actbtn = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button2 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button3 = null;
public anywheresoftware.b4a.objects.SeekBarWrapper _seekbar1 = null;
public anywheresoftware.b4a.objects.LabelWrapper _label1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button5 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button4 = null;
public anywheresoftware.b4a.objects.PanelWrapper _panel1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button6 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button7 = null;
public tw.jylab.blueLT.jylab _jylab = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static class _nameandmac{
public boolean IsInitialized;
public String Name;
public String Mac;
public void Initialize() {
IsInitialized = true;
Name = "";
Mac = "";
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 53;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 55;BA.debugLine="If	FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 56;BA.debugLine="jylab.ResetQ(Qbf)";
mostCurrent._jylab._resetq(mostCurrent.activityBA,(int[])(mostCurrent._qbf));
 //BA.debugLineNum = 57;BA.debugLine="SerialConnected = False";
_serialconnected = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 58;BA.debugLine="serial1.Initialize(\"serial1\")";
_serial1.Initialize("serial1");
 //BA.debugLineNum = 60;BA.debugLine="timer1.Initialize(\"ontime\",100)";
mostCurrent._timer1.Initialize(processBA,"ontime",(long) (100));
 //BA.debugLineNum = 61;BA.debugLine="timer1.Enabled = True";
mostCurrent._timer1.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 63;BA.debugLine="Vals(0)=0";
_vals[(int) (0)] = (int) (0);
 //BA.debugLineNum = 64;BA.debugLine="Vals(1)=0";
_vals[(int) (1)] = (int) (0);
 //BA.debugLineNum = 65;BA.debugLine="Vals(2)=0";
_vals[(int) (2)] = (int) (0);
 };
 //BA.debugLineNum = 68;BA.debugLine="Activity.LoadLayout(\"bluelt_main\")";
mostCurrent._activity.LoadLayout("bluelt_main",mostCurrent.activityBA);
 //BA.debugLineNum = 70;BA.debugLine="PairedDevices = serial1.GetPairedDevices";
_paireddevices = _serial1.GetPairedDevices();
 //BA.debugLineNum = 72;BA.debugLine="actBtn = Button1";
mostCurrent._actbtn = mostCurrent._button1;
 //BA.debugLineNum = 73;BA.debugLine="jylab.SetButtonColor1(Button1,Colors.Green,Colors.Black)";
mostCurrent._jylab._setbuttoncolor1(mostCurrent.activityBA,mostCurrent._button1,BA.NumberToString(anywheresoftware.b4a.keywords.Common.Colors.Green),anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 74;BA.debugLine="jylab.SetButtonColor1(Button2,Colors.Gray,Colors.White)";
mostCurrent._jylab._setbuttoncolor1(mostCurrent.activityBA,mostCurrent._button2,BA.NumberToString(anywheresoftware.b4a.keywords.Common.Colors.Gray),anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 75;BA.debugLine="jylab.SetButtonColor1(Button3,Colors.Gray,Colors.White)";
mostCurrent._jylab._setbuttoncolor1(mostCurrent.activityBA,mostCurrent._button3,BA.NumberToString(anywheresoftware.b4a.keywords.Common.Colors.Gray),anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 76;BA.debugLine="End Sub";
return "";
}
public static boolean  _activity_keypress(int _keycode) throws Exception{
 //BA.debugLineNum = 222;BA.debugLine="Sub Activity_KeyPress (KeyCode As Int) As Boolean 'Return True to consume the event";
 //BA.debugLineNum = 223;BA.debugLine="If KeyCode = KeyCodes.KEYCODE_MENU Then";
if (_keycode==anywheresoftware.b4a.keywords.Common.KeyCodes.KEYCODE_MENU) { 
 //BA.debugLineNum = 224;BA.debugLine="If Panel1.Visible Then";
if (mostCurrent._panel1.getVisible()) { 
 //BA.debugLineNum = 225;BA.debugLine="Panel1.Visible=False";
mostCurrent._panel1.setVisible(anywheresoftware.b4a.keywords.Common.False);
 }else {
 //BA.debugLineNum = 227;BA.debugLine="Panel1.Visible=True";
mostCurrent._panel1.setVisible(anywheresoftware.b4a.keywords.Common.True);
 };
 };
 //BA.debugLineNum = 231;BA.debugLine="End Sub";
return false;
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 82;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 83;BA.debugLine="If	UserClosed = True Then";
if (_userclosed==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 85;BA.debugLine="If timer1.IsInitialized Then";
if (mostCurrent._timer1.IsInitialized()) { 
 //BA.debugLineNum = 86;BA.debugLine="timer1.Enabled = False";
mostCurrent._timer1.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 };
 //BA.debugLineNum = 89;BA.debugLine="If SerialConnected Then";
if (_serialconnected) { 
 //BA.debugLineNum = 90;BA.debugLine="serial1.Disconnect";
_serial1.Disconnect();
 };
 //BA.debugLineNum = 93;BA.debugLine="If	AStream.IsInitialized Then";
if (_astream.IsInitialized()) { 
 //BA.debugLineNum = 94;BA.debugLine="AStream.Close";
_astream.Close();
 };
 //BA.debugLineNum = 97;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 };
 //BA.debugLineNum = 99;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 78;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 80;BA.debugLine="End Sub";
return "";
}
public static String  _astream_error() throws Exception{
 //BA.debugLineNum = 176;BA.debugLine="Sub AStream_Error";
 //BA.debugLineNum = 177;BA.debugLine="ToastMessageShow(\"Connection is broken.\", True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Connection is broken.",anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 178;BA.debugLine="End Sub";
return "";
}
public static String  _astream_newdata(byte[] _buffer) throws Exception{
String _s1 = "";
 //BA.debugLineNum = 124;BA.debugLine="Sub AStream_NewData(buffer() As Byte)";
 //BA.debugLineNum = 125;BA.debugLine="Dim  s1 As String";
_s1 = "";
 //BA.debugLineNum = 127;BA.debugLine="If buffer.Length>0 Then";
if (_buffer.length>0) { 
 };
 //BA.debugLineNum = 129;BA.debugLine="End Sub";
return "";
}
public static String  _astream_terminated() throws Exception{
 //BA.debugLineNum = 180;BA.debugLine="Sub AStream_Terminated";
 //BA.debugLineNum = 181;BA.debugLine="AStream_Error";
_astream_error();
 //BA.debugLineNum = 182;BA.debugLine="End Sub";
return "";
}
public static String  _btnconnect_click() throws Exception{
int _i1 = 0;
anywheresoftware.b4a.objects.collections.List _lt1 = null;
int _i = 0;
int _res = 0;
 //BA.debugLineNum = 131;BA.debugLine="Sub btnConnect_Click";
 //BA.debugLineNum = 132;BA.debugLine="Dim i1 As Int";
_i1 = 0;
 //BA.debugLineNum = 134;BA.debugLine="Panel1.Visible=False";
mostCurrent._panel1.setVisible(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 135;BA.debugLine="If PairedDevices.Size>0 Then";
if (_paireddevices.getSize()>0) { 
 //BA.debugLineNum = 136;BA.debugLine="Dim lt1 As List";
_lt1 = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 138;BA.debugLine="lt1.Initialize";
_lt1.Initialize();
 //BA.debugLineNum = 139;BA.debugLine="For i = 0 To PairedDevices.Size - 1";
{
final int step91 = 1;
final int limit91 = (int) (_paireddevices.getSize()-1);
for (_i = (int) (0); (step91 > 0 && _i <= limit91) || (step91 < 0 && _i >= limit91); _i = ((int)(0 + _i + step91))) {
 //BA.debugLineNum = 140;BA.debugLine="lt1.Add(PairedDevices.GetKeyAt(i))";
_lt1.Add(_paireddevices.GetKeyAt(_i));
 }
};
 //BA.debugLineNum = 144;BA.debugLine="Dim res As Int";
_res = 0;
 //BA.debugLineNum = 145;BA.debugLine="res = InputList(lt1, \"Choose device\", -1) 'show list with paired devices";
_res = anywheresoftware.b4a.keywords.Common.InputList(_lt1,"Choose device",(int) (-1),mostCurrent.activityBA);
 //BA.debugLineNum = 146;BA.debugLine="If res <> DialogResponse.CANCEL Then";
if (_res!=anywheresoftware.b4a.keywords.Common.DialogResponse.CANCEL) { 
 //BA.debugLineNum = 147;BA.debugLine="SelectedDevice.Name = lt1.Get(res)";
_selecteddevice.Name = BA.ObjectToString(_lt1.Get(_res));
 //BA.debugLineNum = 148;BA.debugLine="SelectedDevice.Mac = PairedDevices.Get(SelectedDevice.Name)";
_selecteddevice.Mac = BA.ObjectToString(_paireddevices.Get((Object)(_selecteddevice.Name)));
 //BA.debugLineNum = 149;BA.debugLine="serial1.Connect(SelectedDevice.Mac)";
_serial1.Connect(processBA,_selecteddevice.Mac);
 //BA.debugLineNum = 150;BA.debugLine="Label9.Text = SelectedDevice.Name";
mostCurrent._label9.setText((Object)(_selecteddevice.Name));
 };
 };
 //BA.debugLineNum = 153;BA.debugLine="End Sub";
return "";
}
public static String  _btndisconnect_click() throws Exception{
 //BA.debugLineNum = 233;BA.debugLine="Sub btnDisconnect_Click";
 //BA.debugLineNum = 234;BA.debugLine="Panel1.Visible=False";
mostCurrent._panel1.setVisible(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 235;BA.debugLine="SerialConnected = False";
_serialconnected = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 237;BA.debugLine="AStream.Close";
_astream.Close();
 //BA.debugLineNum = 238;BA.debugLine="serial1.Disconnect";
_serial1.Disconnect();
 //BA.debugLineNum = 240;BA.debugLine="Label9.Text=\"\"";
mostCurrent._label9.setText((Object)(""));
 //BA.debugLineNum = 241;BA.debugLine="End Sub";
return "";
}
public static String  _channel_click() throws Exception{
 //BA.debugLineNum = 184;BA.debugLine="Sub Channel_Click";
 //BA.debugLineNum = 185;BA.debugLine="If	Not(SerialConnected) Then";
if (anywheresoftware.b4a.keywords.Common.Not(_serialconnected)) { 
 //BA.debugLineNum = 186;BA.debugLine="Return";
if (true) return "";
 };
 //BA.debugLineNum = 189;BA.debugLine="If	actBtn <> Sender Then";
if ((mostCurrent._actbtn).equals((android.widget.Button)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA))) == false) { 
 //BA.debugLineNum = 190;BA.debugLine="jylab.SetButtonColor1(actBtn,Colors.Gray,Colors.White)";
mostCurrent._jylab._setbuttoncolor1(mostCurrent.activityBA,mostCurrent._actbtn,BA.NumberToString(anywheresoftware.b4a.keywords.Common.Colors.Gray),anywheresoftware.b4a.keywords.Common.Colors.White);
 };
 //BA.debugLineNum = 193;BA.debugLine="actBtn=Sender";
mostCurrent._actbtn.setObject((android.widget.Button)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 194;BA.debugLine="jylab.SetButtonColor1(actBtn,Colors.Green,Colors.Black)";
mostCurrent._jylab._setbuttoncolor1(mostCurrent.activityBA,mostCurrent._actbtn,BA.NumberToString(anywheresoftware.b4a.keywords.Common.Colors.Green),anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 195;BA.debugLine="actCH = actBtn.Tag";
_actch = (int)(BA.ObjectToNumber(mostCurrent._actbtn.getTag()));
 //BA.debugLineNum = 196;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
jylab._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 26;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 29;BA.debugLine="Dim selected As Int = 0";
_selected = (int) (0);
 //BA.debugLineNum = 30;BA.debugLine="Dim items As Map";
mostCurrent._items = new anywheresoftware.b4a.objects.collections.Map();
 //BA.debugLineNum = 31;BA.debugLine="Dim timer1 As Timer";
mostCurrent._timer1 = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 32;BA.debugLine="Dim Qbf(20) As BltData";
mostCurrent._qbf = new tw.jylab.blueLT.jylab._bltdata[(int) (20)];
{
int d0 = mostCurrent._qbf.length;
for (int i0 = 0;i0 < d0;i0++) {
mostCurrent._qbf[i0] = new tw.jylab.blueLT.jylab._bltdata();
}
}
;
 //BA.debugLineNum = 33;BA.debugLine="Dim actCH As Int=1";
_actch = (int) (1);
 //BA.debugLineNum = 34;BA.debugLine="Dim Vals(3),Programs,Speed As Int";
_vals = new int[(int) (3)];
;
_programs = 0;
_speed = 0;
 //BA.debugLineNum = 37;BA.debugLine="Private Label9 As Label";
mostCurrent._label9 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 38;BA.debugLine="Private btnConnect As Button";
mostCurrent._btnconnect = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 39;BA.debugLine="Private actBtn As Button";
mostCurrent._actbtn = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 40;BA.debugLine="Private Button1 As Button";
mostCurrent._button1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 41;BA.debugLine="Private Button2 As Button";
mostCurrent._button2 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 42;BA.debugLine="Private Button3 As Button";
mostCurrent._button3 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 43;BA.debugLine="Private SeekBar1 As SeekBar";
mostCurrent._seekbar1 = new anywheresoftware.b4a.objects.SeekBarWrapper();
 //BA.debugLineNum = 44;BA.debugLine="Private Label1 As Label";
mostCurrent._label1 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 45;BA.debugLine="Private Button5 As Button";
mostCurrent._button5 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 46;BA.debugLine="Private Button4 As Button";
mostCurrent._button4 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 47;BA.debugLine="Private Panel1 As Panel";
mostCurrent._panel1 = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 48;BA.debugLine="Private Button6 As Button";
mostCurrent._button6 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 49;BA.debugLine="Private Button7 As Button";
mostCurrent._button7 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 50;BA.debugLine="End Sub";
return "";
}
public static String  _ontime_tick() throws Exception{
int _c1 = 0;
String _s1 = "";
 //BA.debugLineNum = 101;BA.debugLine="Sub ontime_Tick";
 //BA.debugLineNum = 102;BA.debugLine="Dim c1 As Int";
_c1 = 0;
 //BA.debugLineNum = 103;BA.debugLine="Dim s1 As String";
_s1 = "";
 //BA.debugLineNum = 105;BA.debugLine="If	Not(SerialConnected) Then";
if (anywheresoftware.b4a.keywords.Common.Not(_serialconnected)) { 
 //BA.debugLineNum = 106;BA.debugLine="Return";
if (true) return "";
 };
 //BA.debugLineNum = 109;BA.debugLine="If Not(AStream.IsInitialized) Then";
if (anywheresoftware.b4a.keywords.Common.Not(_astream.IsInitialized())) { 
 //BA.debugLineNum = 110;BA.debugLine="Return";
if (true) return "";
 };
 //BA.debugLineNum = 113;BA.debugLine="c1=jylab.PopQ(Qbf)";
_c1 = mostCurrent._jylab._popq(mostCurrent.activityBA,mostCurrent._qbf);
 //BA.debugLineNum = 114;BA.debugLine="If	c1 >=0 Then";
if (_c1>=0) { 
 //BA.debugLineNum = 115;BA.debugLine="If (c1>=0)AND(c1<=255) Then";
if ((_c1>=0) && (_c1<=255)) { 
 //BA.debugLineNum = 117;BA.debugLine="s1 = \".$DM\" & actCH & \":\" & c1 & Chr(13)";
_s1 = ".$DM"+BA.NumberToString(_actch)+":"+BA.NumberToString(_c1)+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (13)));
 //BA.debugLineNum = 118;BA.debugLine="jylab.StringToBT(s1,AStream)";
mostCurrent._jylab._stringtobt(mostCurrent.activityBA,_s1,_astream);
 };
 };
 //BA.debugLineNum = 122;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 18;BA.debugLine="Dim serial1 As Serial";
_serial1 = new anywheresoftware.b4a.objects.Serial();
 //BA.debugLineNum = 19;BA.debugLine="Dim AStream As AsyncStreams";
_astream = new anywheresoftware.b4a.randomaccessfile.AsyncStreams();
 //BA.debugLineNum = 20;BA.debugLine="Dim PairedDevices As Map";
_paireddevices = new anywheresoftware.b4a.objects.collections.Map();
 //BA.debugLineNum = 21;BA.debugLine="Type NameAndMac (Name As String, Mac As String)";
;
 //BA.debugLineNum = 22;BA.debugLine="Dim SelectedDevice As NameAndMac";
_selecteddevice = new tw.jylab.blueLT.main._nameandmac();
 //BA.debugLineNum = 23;BA.debugLine="Dim SerialConnected As Boolean";
_serialconnected = false;
 //BA.debugLineNum = 24;BA.debugLine="End Sub";
return "";
}
public static String  _seekbar1_valuechanged(int _value,boolean _userchanged) throws Exception{
 //BA.debugLineNum = 198;BA.debugLine="Sub SeekBar1_ValueChanged (Value As Int, UserChanged As Boolean)";
 //BA.debugLineNum = 199;BA.debugLine="Vals(actCH-1) = Value";
_vals[(int) (_actch-1)] = _value;
 //BA.debugLineNum = 200;BA.debugLine="jylab.PushQ(Qbf,Value)";
mostCurrent._jylab._pushq(mostCurrent.activityBA,mostCurrent._qbf,_value);
 //BA.debugLineNum = 201;BA.debugLine="Label1.Text = Value";
mostCurrent._label1.setText((Object)(_value));
 //BA.debugLineNum = 202;BA.debugLine="End Sub";
return "";
}
public static String  _serial1_connected(boolean _success) throws Exception{
 //BA.debugLineNum = 155;BA.debugLine="Sub serial1_Connected (Success As Boolean)";
 //BA.debugLineNum = 157;BA.debugLine="ProgressDialogHide";
anywheresoftware.b4a.keywords.Common.ProgressDialogHide();
 //BA.debugLineNum = 158;BA.debugLine="Log(\"connected: \" & Success)";
anywheresoftware.b4a.keywords.Common.Log("connected: "+BA.ObjectToString(_success));
 //BA.debugLineNum = 160;BA.debugLine="If Success = False Then";
if (_success==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 161;BA.debugLine="SerialConnected = False";
_serialconnected = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 162;BA.debugLine="ToastMessageShow(\"Error connecting: \" & LastException.Message, True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Error connecting: "+anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),anywheresoftware.b4a.keywords.Common.True);
 }else {
 //BA.debugLineNum = 164;BA.debugLine="SerialConnected = True";
_serialconnected = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 166;BA.debugLine="If Not(	AStream.IsInitialized) Then";
if (anywheresoftware.b4a.keywords.Common.Not(_astream.IsInitialized())) { 
 //BA.debugLineNum = 167;BA.debugLine="AStream.Initialize(serial1.InputStream, serial1.OutputStream, \"AStream\")";
_astream.Initialize(processBA,_serial1.getInputStream(),_serial1.getOutputStream(),"AStream");
 };
 //BA.debugLineNum = 171;BA.debugLine="Label9.text =\"ID : \" & SelectedDevice.Name & CRLF & \"MAC : \" & SelectedDevice.Mac";
mostCurrent._label9.setText((Object)("ID : "+_selecteddevice.Name+anywheresoftware.b4a.keywords.Common.CRLF+"MAC : "+_selecteddevice.Mac));
 };
 //BA.debugLineNum = 174;BA.debugLine="End Sub";
return "";
}
public static String  _updown_click() throws Exception{
int _n1 = 0;
anywheresoftware.b4a.objects.ButtonWrapper _btn = null;
 //BA.debugLineNum = 203;BA.debugLine="Sub UpDown_Click";
 //BA.debugLineNum = 204;BA.debugLine="Dim n1 As Int";
_n1 = 0;
 //BA.debugLineNum = 205;BA.debugLine="Dim btn As Button";
_btn = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 207;BA.debugLine="btn = Sender";
_btn.setObject((android.widget.Button)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 208;BA.debugLine="n1 = Vals(actCH-1)";
_n1 = _vals[(int) (_actch-1)];
 //BA.debugLineNum = 209;BA.debugLine="n1 = n1 + btn.Tag";
_n1 = (int) (_n1+(double)(BA.ObjectToNumber(_btn.getTag())));
 //BA.debugLineNum = 210;BA.debugLine="If	n1<0 Then";
if (_n1<0) { 
 //BA.debugLineNum = 211;BA.debugLine="n1 =0";
_n1 = (int) (0);
 };
 //BA.debugLineNum = 213;BA.debugLine="If	n1 > 255 Then";
if (_n1>255) { 
 //BA.debugLineNum = 214;BA.debugLine="n1 = 255";
_n1 = (int) (255);
 };
 //BA.debugLineNum = 216;BA.debugLine="SeekBar1.Value = n1";
mostCurrent._seekbar1.setValue(_n1);
 //BA.debugLineNum = 217;BA.debugLine="Vals(actCH-1) = n1";
_vals[(int) (_actch-1)] = _n1;
 //BA.debugLineNum = 218;BA.debugLine="jylab.PushQ(Qbf,n1)";
mostCurrent._jylab._pushq(mostCurrent.activityBA,mostCurrent._qbf,_n1);
 //BA.debugLineNum = 219;BA.debugLine="Label1.Text = n1";
mostCurrent._label1.setText((Object)(_n1));
 //BA.debugLineNum = 220;BA.debugLine="End Sub";
return "";
}
}
